diff --git a/ldap/servers/slapd/back-ldbm/ldif2ldbm.c b/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
index ab794a189..3df164be6 100644
--- a/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
+++ b/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
@@ -65,20 +65,6 @@ static int _export_or_index_parents(ldbm_instance *inst, DB *db, back_txn *txn,
 
 /**********  common routines for classic/deluxe import code **********/
 
-static size_t import_config_index_buffer_size = DEFAULT_IMPORT_INDEX_BUFFER_SIZE;
-
-void
-import_configure_index_buffer_size(size_t size)
-{
-    import_config_index_buffer_size = size;
-}
-
-size_t
-import_get_index_buffer_size()
-{
-    return import_config_index_buffer_size;
-}
-
 static PRIntn
 import_subcount_hash_compare_keys(const void *v1, const void *v2)
 {
@@ -113,40 +99,6 @@ import_subcount_stuff_term(import_subcount_stuff *stuff)
     }
 }
 
-/* fetch include/exclude DNs from the pblock and normalize them --
- * returns true if there are any include/exclude DNs
- * [used by both ldif2db and db2ldif]
- */
-int
-ldbm_back_fetch_incl_excl(Slapi_PBlock *pb, char ***include, char ***exclude)
-{
-    char **pb_incl, **pb_excl;
-
-    slapi_pblock_get(pb, SLAPI_LDIF2DB_INCLUDE, &pb_incl);
-    slapi_pblock_get(pb, SLAPI_LDIF2DB_EXCLUDE, &pb_excl);
-    if ((NULL == include) || (NULL == exclude)) {
-        return 0;
-    }
-    *include = *exclude = NULL;
-
-    /* pb_incl/excl are both normalized */
-    *exclude = slapi_ch_array_dup(pb_excl);
-    *include = slapi_ch_array_dup(pb_incl);
-
-    return (pb_incl || pb_excl);
-}
-
-void
-ldbm_back_free_incl_excl(char **include, char **exclude)
-{
-    if (include) {
-        charray_free(include);
-    }
-    if (exclude) {
-        charray_free(exclude);
-    }
-}
-
 /* check if a DN is in the include list but NOT the exclude list
  * [used by both ldif2db and db2ldif]
  */
@@ -182,141 +134,6 @@ ldbm_back_ok_to_dump(const char *dn, char **include, char **exclude)
 }
 
 
-/*
- * add_op_attrs - add the parentid, entryid, dncomp,
- * and entrydn operational attributes to an entry.
- * Also---new improved washes whiter than white version
- * now removes any bogus operational attributes you're not
- * allowed to specify yourself on entries.
- * Currenty the list of these is: numSubordinates, hasSubordinates
- */
-int
-add_op_attrs(Slapi_PBlock *pb, struct ldbminfo *li __attribute__((unused)), struct backentry *ep, int *status)
-{
-    backend *be;
-    char *pdn;
-    ID pid = 0;
-    int save_old_pid = 0;
-    int is_tombstone = 0;
-
-    slapi_pblock_get(pb, SLAPI_BACKEND, &be);
-
-    /*
-     * add the parentid and entryid operational attributes
-     */
-
-    if (NULL != status) {
-        if (IMPORT_ADD_OP_ATTRS_SAVE_OLD_PID == *status) {
-            save_old_pid = 1;
-        }
-        *status = IMPORT_ADD_OP_ATTRS_OK;
-    }
-
-    is_tombstone = slapi_entry_flag_is_set(ep->ep_entry,
-                                           SLAPI_ENTRY_FLAG_TOMBSTONE);
-    /* parentid */
-    if ((pdn = slapi_dn_parent_ext(backentry_get_ndn(ep), is_tombstone)) != NULL) {
-        int err = 0;
-
-        /*
-         * read the entrydn/entryrdn index to get the id of the parent
-         * If this entry's parent is not present in the index,
-         * we'll get a DB_NOTFOUND error here.
-         * In olden times, we just ignored this, but now...
-         * we see this as meaning that the entry is either a
-         * suffix entry, or its erroneous. So, we signal this to the
-         * caller via the status parameter.
-         */
-        if (entryrdn_get_switch()) { /* subtree-rename: on */
-            Slapi_DN sdn;
-            slapi_sdn_init(&sdn);
-            slapi_sdn_set_dn_byval(&sdn, pdn);
-            err = entryrdn_index_read_ext(be, &sdn, &pid,
-                                          TOMBSTONE_INCLUDED, NULL);
-            slapi_sdn_done(&sdn);
-            if (DB_NOTFOUND == err) {
-                /*
-                 * Could be a tombstone. E.g.,
-                 * nsuniqueid=042d8081-..-ca8fe9f7,uid=tuser,o=abc,com
-                 * If so, need to get the grandparent of the leaf.
-                 */
-                if (slapi_entry_flag_is_set(ep->ep_entry,
-                                            SLAPI_ENTRY_FLAG_TOMBSTONE) &&
-                    (0 == strncasecmp(pdn, SLAPI_ATTR_UNIQUEID,
-                                      sizeof(SLAPI_ATTR_UNIQUEID) - 1))) {
-                    char *ppdn = slapi_dn_parent(pdn);
-                    slapi_ch_free_string(&pdn);
-                    if (NULL == ppdn) {
-                        if (NULL != status) {
-                            *status = IMPORT_ADD_OP_ATTRS_NO_PARENT;
-                            goto next;
-                        }
-                    }
-                    pdn = ppdn;
-                    slapi_sdn_set_dn_byval(&sdn, pdn);
-                    err = entryrdn_index_read(be, &sdn, &pid, NULL);
-                    slapi_sdn_done(&sdn);
-                }
-            }
-            if (err) {
-                if (DB_NOTFOUND != err && 1 != err) {
-                    slapi_log_err(SLAPI_LOG_ERR, "add_op_attrs", "database error %d\n", err);
-                    slapi_ch_free_string(&pdn);
-                    return (-1);
-                }
-                if (NULL != status) {
-                    *status = IMPORT_ADD_OP_ATTRS_NO_PARENT;
-                }
-            }
-        } else {
-            struct berval bv;
-            IDList *idl = NULL;
-            bv.bv_val = pdn;
-            bv.bv_len = strlen(pdn);
-            if ((idl = index_read(be, LDBM_ENTRYDN_STR, indextype_EQUALITY,
-                                  &bv, NULL, &err)) != NULL) {
-                pid = idl_firstid(idl);
-                idl_free(&idl);
-            } else {
-                /* empty idl */
-                if (0 != err && DB_NOTFOUND != err) {
-                    slapi_log_err(SLAPI_LOG_ERR, "add_op_attrs", "database error %d\n", err);
-                    slapi_ch_free_string(&pdn);
-                    return (-1);
-                }
-                if (NULL != status) {
-                    *status = IMPORT_ADD_OP_ATTRS_NO_PARENT;
-                }
-            }
-        }
-        slapi_ch_free_string(&pdn);
-    } else {
-        if (NULL != status) {
-            *status = IMPORT_ADD_OP_ATTRS_NO_PARENT;
-        }
-    }
-next:
-    /* Get rid of attributes you're not allowed to specify yourself */
-    slapi_entry_delete_values(ep->ep_entry, hassubordinates, NULL);
-    slapi_entry_delete_values(ep->ep_entry, numsubordinates, NULL);
-
-    /* Upgrade DN format only */
-    /* Set current parentid to e_aux_attrs to remove it from the index file. */
-    if (save_old_pid) {
-        Slapi_Attr *pid_attr = NULL;
-        pid_attr = attrlist_remove(&ep->ep_entry->e_attrs, "parentid");
-        if (pid_attr) {
-            attrlist_add(&ep->ep_entry->e_aux_attrs, pid_attr);
-        }
-    }
-
-    /* Add the entryid, parentid and entrydn operational attributes */
-    /* Note: This function is provided by the Add code */
-    add_update_entry_operational_attributes(ep, pid);
-
-    return (0);
-}
-
 /**********  functions for maintaining the subordinate count **********/
 
 /* Update subordinate count in a hint list, given the parent's ID */
@@ -663,16 +480,9 @@ int
 ldbm_back_ldif2ldbm(Slapi_PBlock *pb)
 {
     struct ldbminfo *li;
-    ldbm_instance *inst = NULL;
-    char *instance_name;
-    int ret, task_flags;
+    int rc, task_flags;
 
     slapi_pblock_get(pb, SLAPI_PLUGIN_PRIVATE, &li);
-    slapi_pblock_get(pb, SLAPI_BACKEND_INSTANCE_NAME, &instance_name);
-
-    /* BEGIN complex dependencies of various initializations. */
-    /* hopefully this will go away once import is not run standalone... */
-
     slapi_pblock_get(pb, SLAPI_TASK_FLAGS, &task_flags);
     if (task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE) {
         /* initialize UniqueID generator - must be done once backends are started
@@ -680,7 +490,7 @@ ldbm_back_ldif2ldbm(Slapi_PBlock *pb)
         /* This dn is normalize. */
         Slapi_DN *sdn =
             slapi_sdn_new_ndn_byref("cn=uniqueid generator,cn=config");
-        int rc = uniqueIDGenInit(NULL, sdn /*const*/,
+            rc = uniqueIDGenInit(NULL, sdn /*const*/,
                                  0 /* use single thread mode */);
         slapi_sdn_free(&sdn);
         if (rc != UID_SUCCESS) {
@@ -691,125 +501,12 @@ ldbm_back_ldif2ldbm(Slapi_PBlock *pb)
             return -1;
         }
 
+        dblayer_setup(li);
         li->li_flags |= SLAPI_TASK_RUNNING_FROM_COMMANDLINE;
-        ldbm_config_load_dse_info(li);
-    }
-
-    /* Find the instance that the ldif2db will be done on. */
-    inst = ldbm_instance_find_by_name(li, instance_name);
-    if (NULL == inst) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldif2ldbm", "Unknown ldbm instance %s\n",
-                      instance_name);
-        return -1;
-    }
-
-    /* check if an import/restore is already ongoing... */
-    if ((instance_set_busy(inst) != 0) ||
-        (slapi_counter_get_value(inst->inst_ref_count) > 0)) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldif2ldbm", "ldbm: '%s' is already in the middle of "
-                                                            "another task and cannot be disturbed.\n",
-                      inst->inst_name);
-        return -1;
-    }
-
-    if ((task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE)) {
-        if (dblayer_import_file_init(inst)) {
-            slapi_log_err(SLAPI_LOG_ERR,
-                          "ldbm_back_ldif2ldbm", "Failed to write import file\n");
-            return -1;
-        }
     }
+    dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
 
-    /***** prepare & init libdb and dblayer *****/
-
-    if (!(task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE)) {
-        /* shutdown this instance of the db */
-        slapi_log_err(SLAPI_LOG_INFO, "ldbm_back_ldif2ldbm", "Bringing %s offline...\n",
-                      instance_name);
-        slapi_mtn_be_disable(inst->inst_be);
-
-        cache_clear(&inst->inst_cache, CACHE_TYPE_ENTRY);
-        if (entryrdn_get_switch()) {
-            cache_clear(&inst->inst_dncache, CACHE_TYPE_DN);
-        }
-        dblayer_instance_close(inst->inst_be);
-        dblayer_delete_indices(inst);
-    } else {
-        /* from the command line, libdb needs to be started up */
-        ldbm_config_internal_set(li, CONFIG_DB_TRANSACTION_LOGGING, "off");
-
-        /* If USN plugin is enabled,
-         * initialize the USN counter to get the next USN */
-        if (plugin_enabled("USN", li->li_identity)) {
-            /* close immediately; no need to run db threads */
-            ret = dblayer_start(li,
-                                DBLAYER_NORMAL_MODE | DBLAYER_NO_DBTHREADS_MODE);
-            if (ret) {
-                slapi_log_err(SLAPI_LOG_ERR,
-                              "ldbm_back_ldif2ldbm", "dblayer_start failed! %s (%d)\n",
-                              dblayer_strerror(ret), ret);
-                goto fail;
-            }
-            /* initialize the USN counter */
-            ldbm_usn_init(li);
-            ret = dblayer_close(li, DBLAYER_NORMAL_MODE);
-            if (ret != 0) {
-                slapi_log_err(SLAPI_LOG_ERR,
-                              "ldbm_back_ldif2ldbm", "dblayer_close failed! %s (%d)\n",
-                              dblayer_strerror(ret), ret);
-            }
-        }
-
-        if (0 != (ret = dblayer_start(li, DBLAYER_IMPORT_MODE))) {
-            if (LDBM_OS_ERR_IS_DISKFULL(ret)) {
-                slapi_log_err(SLAPI_LOG_ALERT, "ldbm_back_ldif2ldbm", "Failed to init database.  "
-                                                                      "There is either insufficient disk space or "
-                                                                      "insufficient memory available to initialize the "
-                                                                      "database.\n");
-                slapi_log_err(SLAPI_LOG_ALERT, "ldbm_back_ldif2ldbm", "Please check that\n"
-                                                                      "1) disks are not full,\n"
-                                                                      "2) no file exceeds the file size limit,\n"
-                                                                      "3) the configured dbcachesize is not too large for the available memory on this machine.\n");
-            } else {
-                slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldif2ldbm", "Failed to init database "
-                                                                    "(error %d: %s)\n",
-                              ret, dblayer_strerror(ret));
-            }
-            goto fail;
-        }
-    }
-
-    /* Delete old database files */
-    dblayer_delete_instance_dir(inst->inst_be);
-    /* it's okay to fail -- the directory might have already been deleted */
-
-    /* dblayer_instance_start will init the id2entry index. */
-    /* it also (finally) fills in inst_dir_name */
-    ret = dblayer_instance_start(inst->inst_be, DBLAYER_IMPORT_MODE);
-    if (ret != 0) {
-        goto fail;
-    }
-
-    vlv_init(inst);
-
-    /***** done init libdb and dblayer *****/
-
-    /* always use "new" import code now */
-    slapi_pblock_set(pb, SLAPI_BACKEND, inst->inst_be);
-    ret = ldbm_back_ldif2ldbm_deluxe(pb);
-    if (ret == 0) {
-        if (task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE) {
-            dblayer_import_file_update(inst);
-        } else {
-            slapi_be_set_flag(inst->inst_be, SLAPI_BE_FLAG_POST_IMPORT);
-        }
-    }
-    return ret;
-
-fail:
-    /* DON'T enable the backend -- leave it offline */
-    instance_set_not_busy(inst);
-    return ret;
+    return priv->dblayer_ldif2db_fn(pb);;
 }
 
 
